# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'ProductAvailability',
    'ProductType',
]


class ProductAvailability(str, Enum):
    """
    The online availability of the Product. Default to Availability.IN_STOCK. Google Merchant Center Property [availability](https://support.google.com/merchants/answer/6324448). Schema.org Property [Offer.availability](https://schema.org/availability).
    """
    AVAILABILITY_UNSPECIFIED = "AVAILABILITY_UNSPECIFIED"
    """
    Default product availability. Default to Availability.IN_STOCK if unset.
    """
    IN_STOCK = "IN_STOCK"
    """
    Product in stock.
    """
    OUT_OF_STOCK = "OUT_OF_STOCK"
    """
    Product out of stock.
    """
    PREORDER = "PREORDER"
    """
    Product that is in pre-order state.
    """
    BACKORDER = "BACKORDER"
    """
    Product that is back-ordered (i.e. temporarily out of stock).
    """


class ProductType(str, Enum):
    """
    Immutable. The type of the product. Default to Catalog.product_level_config.ingestion_product_type if unset.
    """
    TYPE_UNSPECIFIED = "TYPE_UNSPECIFIED"
    """
    Default value. Default to Catalog.product_level_config.ingestion_product_type if unset.
    """
    PRIMARY = "PRIMARY"
    """
    The primary type. As the primary unit for predicting, indexing and search serving, a Type.PRIMARY Product is grouped with multiple Type.VARIANT Products.
    """
    VARIANT = "VARIANT"
    """
    The variant type. Type.VARIANT Products usually share some common attributes on the same Type.PRIMARY Products, but they have variant attributes like different colors, sizes and prices, etc.
    """
    COLLECTION = "COLLECTION"
    """
    The collection type. Collection products are bundled Type.PRIMARY Products or Type.VARIANT Products that are sold together, such as a jewelry set with necklaces, earrings and rings, etc.
    """
